function [mu,A,Cov,P,CovP,sresid,rest] = ecevar(z,lags,rest0);

k = size(z,2);
bigt = size(z,1);

y = z(lags+1:end,:);

x = ones(bigt-lags,1);

for ii = 1:lags,
    x = [x z(lags+1-ii:end-ii,:)];
end;

bols = inv(x'*x)*(x'*y);

% if zero restrictions are to be imposed...

if prod(size(rest0)) > 1,
    
 [mu2,Asig,Cov2] = ivecvar(rest0);

 b2 = zeros(size(bols));
 for ii = 1:k,
    b2([1==1; (Asig(ii,:)==1)'],ii)=regress(y(:,ii),x(:,[(1==1); (Asig(ii,:)==1)']));
 end;
 
 bols = b2; 
 
end;

 mu = bols(1,:)';
 A  = bols(2:end,:)';
 resid = y-x*bols;
 Cov = cov(y-x*bols);
 resid  = y-x*bols;
 sresid = resid*inv(chol(Cov));
  
% standard errors 

Q = (x'*x)/bigt;
W = Cov;
D = duplication(k);
Dp = inv(D'*D)*D';
S2 = 2*Dp*kron(W,W)*Dp';

B = bols;
CovB = kron(W,inv(Q))/bigt;
CovSig = S2/bigt;

P    = [reshape([mu';A'],k*(k+1),1); Dp*reshape(Cov,k^2,1)];
CovP = [[CovB zeros(k*(k+1),k*(k+1)/2)];[zeros(k*(k+1)/2,k*(k+1)) CovSig]];

% identify imprecisely estimated coefficients (tstat<1)
P2 = ones(size(P));
P2(abs(P./(sqrt(diag(CovP))))<1) = 0;

rest = P2;

% second stage: re-estimate, forcing zeros for all slope
% coefficeint estimates with low precision (tstat<1)

if rest0 == 1,

P2 = ones(size(P));
P2(abs(P./(sqrt(diag(CovP))))<1) = 0;
[mu2,Asig,Cov2] = ivecvar(P2);

b2 = zeros(size(bols));
for ii = 1:k,
    b2([1==1; (Asig(ii,:)==1)'],ii)=regress(y(:,ii),x(:,[(1==1); (Asig(ii,:)==1)']));
end;

 mu = b2(1,:)';
 A  = b2(2:end,:)';
 resid = y-x*b2;
 Cov = cov(y-x*b2);
 resid  = y-x*b2;
 sresid = resid*inv(chol(Cov));
  
% standard errors 

Q = (x'*x)/bigt;
W = Cov;
D = duplication(k);
Dp = inv(D'*D)*D';
S2 = 2*Dp*kron(W,W)*Dp';

B = b2;
CovB = kron(W,inv(Q))/bigt;
CovSig = S2/bigt;

P    = [reshape([mu';A'],k*(k+1),1); Dp*reshape(Cov,k^2,1)];
CovP = [[CovB zeros(k*(k+1),k*(k+1)/2)];[zeros(k*(k+1)/2,k*(k+1)) CovSig]];

end;
