clear all;

% load real data and make some calculations;
[numeric,txt,raw]=xlsread('/cm/research/engstrom/ECEResearch/Bekaert/BE_Pred/data/fedmodel_feb08.xls','data');
txt2 = char(txt);
for jj = 1:size(txt2,1);
 eval([txt2(jj,:) ' = numeric(:,' num2str(jj) ');']);
end;

global h;

% epsilon for gradient calculation
h = 1e-6;

%%% DATA PREPARATION

% load filtered uncertatinty measures caculated in ../FAVAR directory
 load ../FAVAR/filt;
 
% generate a smoothed earnings series 
lam = 0.1000;
bigt = size(ny,1);
ewgts = (1+lam).^(1:bigt)';
de = (ny.*prc)./(0.5*exp(1.00875.^(1:bigt(1))'));
ew_de = cumsum(ewgts.*de)./cumsum(ewgts);
e_smooth = ew_de.*(0.5*exp(1.00875.^(1:bigt(1))'));
 
 
% filter missing obs of epi_4q
 xxx = epi_4q;
 [mu,A,Cov,P,CovP] = ecevar(xxx(30:end),1,0);
 mxxx = (inv(eye(1)-A)*mu)';
 xxx2 = xxx - repmat(mxxx,size(xxx,1),1);
 [x11, z11, P11, x1T, z1T, P1T, ll, K, x1S, z1S, z1Sfull, sll] = kalman(A,eye(1),Cov,zeros(1), xxx2', 1, 1,1./[0]');
 epi_4qf = x1T(end,:)' + mxxx(end);
 
% filter missing obs of epi_lt
 xxx = [epi_4qf spi_filt' by/400 ry/400 epi_lt];
 [mu,A,Cov,P,CovP] = ecevar(xxx(93:end-13,:),1,0);
 mxxx = (inv(eye(5)-A)*mu)';
 xxx2 = xxx - repmat(mxxx,size(xxx,1),1);
 [x11, z11, P11, x1T, z1T, P1T, ll, K, x1S, z1S, z1Sfull, sll] = kalman(A,eye(5),Cov,zeros(5), xxx2', 4, 1,1./[0 0 0 0 0]');
 epi_ltf = x1T(end,:)' + mxxx(end);
 
% filter missing obs of enp_4q
 xxx = enp_4q;
 [mu,A,Cov,P,CovP] = ecevar(xxx(30:end),1,0);
 mxxx = (inv(eye(1)-A)*mu)';
 xxx2 = xxx - repmat(mxxx,size(xxx,1),1);
 [x11, z11, P11, x1T, z1T, P1T, ll, K, x1S, z1S, z1Sfull, sll] = kalman(A,eye(1),Cov,zeros(1), xxx2', 1, 1,1./[0]');
 enp_4qf = x1T(end,:)' + mxxx(end);
 
% filter missing obs of abw (ang, bekaert, wei)
 xxx = [epi_4qf spi_filt' by/400 ry/400];
 [mu,A,Cov,P,CovP] = ecevar(xxx(1:end-13,:),1,0);
 mxxx = (inv(eye(4)-A)*mu)';
 xxx2 = xxx - repmat(mxxx,size(xxx,1),1);
 [x11, z11, P11, x1T, z1T, P1T, ll, K, x1S, z1S, z1Sfull, sll] = kalman(A,eye(4),Cov,zeros(4), xxx2', 4, 1,1./[0 0 0 0]');
 abwf = x1T(end,:)' + mxxx(end);

 
 abw_alt = (by-epi_ltf*100-.1*(spi_filt'+6))/400;
 
% define observables for use.  everyting quarterly rate
   ey  = log(dy); 
  %ey  = log(e_smooth./prc);
  %ey  = log(yy); 
  %ey  = log(0.5*ny);
  by  = log(1+by/400); 
 einf = epi_4qf/4; % epi_ltf/4 or epi_4qf/4; 
 egch = ge - api_1q;
 agch = gd - api_1q;
 %agch = gy - api_1q;
 erp_4qf = enp_4qf - epi_4qf;
 rgld = log(gold./cpi)/10;
 
 % Figure 1 plot
plotyy(ndate,100*exp(ey)*4,ndate, 100*by*4)
text(1969,5.25,'equity')
text(1969,5,'(left scale)')
text(1970,2,'nominal bond')
text(1970,1.75,'(right scale)')
text(1967,7.5,'Percent, Annual Rate')
title('Equity and Nominal Bond Yields','FontSize',14)

 % Figure 1 plot alt
plot(ndate,100*ny*4,ndate, 100*by*4)
text(1972,12,'equity')
text(1975,6.5,'nominal bond')
text(1967,17.5,'Percent, Annual Rate')
title('Equity Earnings Yields and Nominal Bond Yields','FontSize',14)

% Figure 2 plot
plotyy(ndate,ccra,ndate, sgr_filt)
title('Risk Aversion and Real Uncertatinty','FontSize',14)
text(1967,4.55,'Log level')
text(2003,4.55,'Index level')
text(1999,3.8,'Risk Aversion')
text(1999,3.75,'(left scale)')
text(1966,4.25,'Real Uncertainty')
text(1966,4.20,'(right scale)')

% do a duration calculation for the bond (assume par bond with maturity 20 1/2 years)
Dury = 2*(exp(by)-1);
DurC = 100*Dury;
Durn = 20;
DurP = 100;
DurM = 100;
MacD = ( DurC./(Dury.^2).*(1-(1+Dury).^(-Durn)) + Durn*(DurM-DurC./Dury).*(1+Dury).^(-Durn-1) )./DurP.*(1+Dury)/2;
 
rho = 1/(1+exp(mean(ey)));
kap = -log(rho)-(1-rho)*log(1/rho-1);

% observable data vector

lnb = -0.0050;
gam =  2.5000;

m0 = lnb;
e_m1 =  gam*[0 1 0 0 0]';
e_m2 = -gam*[0 1 0 0 0]';

d0     = 0;
e_d1   =      [0 0 0 0 1]';
e_d2   =      [0 0 0 0 0]';

lam    = 10;

Wdata = [einf ccra sgr_filt' erp_4qf agch]; 
Zdata = [-ey]; 

rest0 = 0;
[muW,AW,CovW,PW,CovPW,sresid,rest1] = ecevar(W,1,rest0);

xfunct = @(pvec) pdobj(pvec, m0, e_m1, e_m2, d0, e_d1, e_d2, muW, AW, CovW, kap, rho, Wdata, Zdata, lam);
options1 = optimset('TolX',1e-6,'TolFun',1e-6,'MaxFunEvals',1e5,'MaxIter',1e5);

[pvec0,bint,r,rint,stats] = regress(Zdata,[ones(size(Wdata(:,1))) Wdata]);

%pvec0 = [mean(-ey) 0 0 0 0 0]';
pvecl = -100*ones(size(pvec0));
pvecu =  100*ones(size(pvec0));

[pvec1,fval,xflag,outoput,lambda,grad,hess] = fmincon(xfunct,pvec0,[],[],[],[],pvecl,pvecu,[],options1);


