function [VZd, VZds] = vardecompvar(P,s,Cov);

global h;      

% reports variance decomposition for ordered VARs
% with standard errors for z = theta + Theta*Y and Y follows a VAR
% the data *must* be arranged so that the first elements of
% z are y, in order


% function handle so only the parameters are needed
irh = @(p) ir(p,s);  

% point estimate
[f0 sOutVec] = irh(P);


ht = h/10;
% gradient
paramdim  = size(P',2);
ndx       = reshape((1:paramdim),paramdim,1);
for i = 1:paramdim
    di = ht*(ndx==i)';
    ft = irh(P+di');
  G(:,i) = (ft'-f0')/(ht);
end;

% done, just reorganize
CovOutVec = G*Cov*G';
[VZd] = imvec(f0,sOutVec);
[VZds] = imvec(sqrt(diag(CovOutVec)),sOutVec);

% subfunction

function [OutVec,sOutVec] = ir(P,s);

[theta,Theta,mu,A,Cov] = imvec(P,s);

k = size(A,1);
n = size(theta,1);

EZ0  = theta + Theta*inv(eye(k)-A)*mu;
VZ0  = Theta*reshape(inv(eye(k^2)-kron(A,A))*reshape(Cov,k^2,1),k,k)*Theta';

VZd(:,:,1) = VZ0;
for ii = 1:k,
    sii  = zeros(k);
    sii(ii,ii) = 1;
    Omii = chol(Cov)'*sii*chol(Cov);
    VZd(:,:,ii+1) = Theta*reshape(inv(eye(k^2)-kron(A,A))*reshape(Omii,k^2,1),k,k)*Theta';
end;

[OutVec, sOutVec] = mvec(VZd);